package com.ecnu.platform.port

import com.ecnu.alg.pojo.port.inputs.AlgShoreline
import com.three.common.utils.IdWorker
import com.three.common.vo.PageResult
import com.three.data_api.dm.annos.BizApiMethod
import com.three.data_api.dm.annos.Doc4MethodRes
import com.three.data_api.dm.constants.ThreeConstant
import com.three.data_api.dm.entity.AuqResult
import com.three.redis.utils.RedisUtil
import org.springframework.beans.factory.annotation.Autowired

class ShorelineService {

    public static final String AlgShorelineKey = "port:AlgShoreline:"

    @Autowired
    private RedisUtil redisUtil;

    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "查询岸线信息")
    @Doc4MethodRes(key = "result", desc = "岸线信息", refClasses = AlgShoreline.class)
    AuqResult query(Map<String, Object> map) throws Exception {
        List<AlgShoreline> algShorelineList = redisUtil.getByPrefix(AlgShorelineKey + "*") as List<AlgShoreline>
        AuqResult auqResult = new AuqResult();
        PageResult pageResult = new PageResult();
        pageResult.setData(algShorelineList)
        auqResult.setResult(pageResult)
        return auqResult
    }

    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "新增岸线信息")
    void create(Map<String, Object> map) throws Exception {
        // 先删除岸线
        redisUtil.del(redisUtil.getKeyByPrefix(AlgShorelineKey + "*"))
        AlgShoreline algShoreline = new AlgShoreline()
        algShoreline.setGkey(IdWorker.generateIdStr())
        algShoreline.setId("test")
        algShoreline.setTmlId("test")
        algShoreline.setLength(2000)
        redisUtil.set(AlgShorelineKey + algShoreline.getGkey(), algShoreline)
    }
}
